#ifndef	LUZJUGADOR_H
#define	LUZJUGADOR_H

#include "genesis.h"

#pragma warning( disable : 4068 )

#pragma GE_Type("dynlight.bmp")

typedef struct	LuzJugador
{
#pragma	GE_Private
	geFloat			LastTime;
	geFloat			IntervalWidth;
	int				NumFunctionValues;
	geLight *		DynLight;
	
#pragma GE_Published
    geVec3d			origin;
    int				MinRadius;
    int				MaxRadius;
	int				InterpolateValues;
	int				AllowRotation;
    char *			RadiusFunction;
    geFloat			RadiusSpeed;
    GE_RGBA			Color;
	geFloat			Arc;

#pragma GE_Origin(origin)
#pragma GE_DefaultValue(MinRadius, "500")
#pragma GE_DefaultValue(MaxRadius, "700")
#pragma GE_DefaultValue(Color, "247.0 207.0 72.0")
#pragma GE_DefaultValue(RadiusFunction, "nqntmrmtuvpo")
#pragma GE_DefaultValue(RadiusSpeed, "6.0")
#pragma GE_DefaultValue(InterpolateValues, "1")
#pragma GE_DefaultValue(AllowRotation, "1")

#pragma GE_Documentation(MinRadius, "Minimum radius of the light (texels)")
#pragma GE_Documentation(MaxRadius, "Maximum radius of the light (texels)")
#pragma GE_Documentation(InterpolateValues, "0 or 1.  Whether to interpolate between the RadiusFunction values")
#pragma GE_Documentation(AllowRotation, "0 or 1.  Whether or not to follow the model rotation if the light is attached to a model")
#pragma GE_Documentation(RadiusFunction, "a-z, repeated (E.g. aabdfzddsfdz)  Specify light values over time.  a = Minimum z = maximum")
#pragma GE_Documentation(RadiusSpeed, "How fast to run through RadiusFunction values (seconds)")
#pragma GE_Documentation(Color, "Color of the light")

#pragma GE_Arc(Arc)
#pragma GE_DefaultValue(Arc, "0")
#pragma GE_Documentation(Arc, "Apertura del foco de luz. 0=Antorcha. 55=Linterna")

}	LuzJugador;

geBoolean	LuzJugador_Init(geEngine *Engine, geWorld *World, geVFile *Context);
geBoolean	LuzJugador_Reset(geWorld *World);
geBoolean	LuzJugador_Frame(geWorld *World, const geXForm3d *ViewPoint, geFloat Time);
geBoolean	LuzJugador_Shutdown(void);

#pragma warning( default : 4068 )

#endif

