// USERTYPES.H -- Genesis Editor standard entity types
//
// Copyright  1999, WildTangent, Inc.

/****************************************************************************************/
/*  Modificaciones para Entidad 3D:                                                     */
/*                                                                                      */
/*  Autor: Jordi Prez                                                                  */
/*                                                                                      */
/*  Copyright (c) 2005 Jordi Prez; All rights reserved.                                */
/*                                                                                      */
/*                                                                                      */
/****************************************************************************************/

#ifndef GENVS_H
#define GENVS_H

#include "Quatern.h"
#include "GenVSI.h"

#include "PhysicsObject.h"
#include "PhysicsJoint.h"
#include "PhysicsSystem.h"

#include "botact.h"

#pragma warning( disable : 4068 )
#ifdef __cplusplus
extern "C" {
#endif

#pragma GE_BrushContents
typedef enum
{
	Water = 0x00010000,
	Lava = 0x00020000,
	Ladder = 0x00040000,
	/*
	type4 = 0x00080000,
	type5 = 0x00100000,
	type6 = 0x00200000,
	type7 = 0x00400000,
	type8 = 0x00800000,
	type9 = 0x01000000,
	type10 = 0x02000000,
	type11 = 0x04000000,
	type12 = 0x08000000,
	type13 = 0x10000000,
	type14 = 0x20000000,
	type15 = 0x40000000,
	type16 = 0x80000000
	*/
} UserContentsEnum;

// Playerstart
#pragma GE_Type("Player.ico")
typedef struct	PlayerStart
{
#pragma GE_Published
    geVec3d     Origin;
#pragma GE_Origin(Origin)
}	PlayerStart;



// DeathMatchStart
#pragma GE_Type("Player.ico")
typedef struct  DeathMatchStart
{
#pragma GE_Published
    geVec3d     Origin;
	char *Anim_agachado_Idle;
	#pragma GE_DefaultValue(Anim_agachado_Idle, "")
	#pragma GE_Documentation(Anim_agachado_Idle, "Nombre animacin del personaje parado agachado. Normalmente 'Idle_agachado'")

	char *Anim_agachado_Walk;
	#pragma GE_DefaultValue(Anim_agachado_Walk, "")
	#pragma GE_Documentation(Anim_agachado_Walk, "Nombre animacin del personaje caminando agachado. Normalmente 'Walk_agachado'")

	char *Anim_salto;
	#pragma GE_DefaultValue(Anim_salto, "")
	#pragma GE_Documentation(Anim_salto, "Nombre de animacin para el salto del personaje. Normalmente 'JumpLand'")

	char *Anim_escalar;
	#pragma GE_DefaultValue(Anim_escalar, "")
	#pragma GE_Documentation(Anim_escalar, "Nombre de animacin del personaje escalando. Normalmente 'Escalar'")

	geBoolean   Avance_direccion;
	#pragma GE_DefaultValue(Avance_direccion, "False")
	#pragma GE_Documentation(Avance_direccion, "Avance del jugador segn las teclas de direccin. False=No True=Si")

	int	Vidas;
	#pragma GE_DefaultValue(Vidas, "3")
	#pragma GE_Documentation(Vidas, "Nmero de vidas iniciales del jugador")

	geBoolean   Jugador_masculino;
	#pragma GE_DefaultValue(Jugador_masculino, "True")
	#pragma GE_Documentation(Jugador_masculino, "Gnero del personaje del jugador. True=Masculino False=Femenino")

	int	Salto_jugador;
	#pragma GE_DefaultValue(Salto_jugador, "510")
	#pragma GE_Documentation(Salto_jugador, "Altura a la que saltar el jugador. Entre 0 y 5000. 0 no salta")

	int	Brillo_jugador;
	#pragma GE_DefaultValue(Brillo_jugador, "200")
	#pragma GE_Documentation(Brillo_jugador, "Nivel de brillo que se aplicar al jugador. Entre 0 y 255")

	geBoolean   Movimiento_lateral;
	#pragma GE_DefaultValue(Movimiento_lateral, "True")
	#pragma GE_Documentation(Movimiento_lateral, "Permitir movimiento lateral al jugador. True=Si False=No")

	geVec3d		Colision_player1p;
	#pragma GE_DefaultValue(Colision_player1p, "0 0 0")
	#pragma GE_Documentation(Colision_player1p, "Correccin de colisin jugador (+). De 0 a 2000.")

	geVec3d		Colision_player1n;
	#pragma GE_DefaultValue(Colision_player1n, "0 0 0")
	#pragma GE_Documentation(Colision_player1n, "Correccin de colisin jugador (-). De 0 a -2000.")

	geVec3d		Colision_player2p;
	#pragma GE_DefaultValue(Colision_player2p, "0 0 0")
	#pragma GE_Documentation(Colision_player2p, "Correccin de colisin jugador (+). De 0 a 2000.")

	geVec3d		Colision_player2n;
	#pragma GE_DefaultValue(Colision_player2n, "0 0 0")
	#pragma GE_Documentation(Colision_player2n, "Correccin de colisin jugador (-). De 0 a -2000.")

	geBoolean   Sonido_pasos;
	#pragma GE_DefaultValue(Sonido_pasos, "True")
	#pragma GE_Documentation(Sonido_pasos, " Sonido de pasos al correr el jugador ?. False=No True=Si")

	geBoolean   Pierde_armas;
	#pragma GE_DefaultValue(Pierde_armas, "False")
	#pragma GE_Documentation(Pierde_armas, "El jugador pierde sus armas al morir. True=Si False=No")

	geBoolean   Ver_arma;
	#pragma GE_DefaultValue(Ver_arma, "False")
	#pragma GE_Documentation(Ver_arma, " Ver arma en primera persona ?. False=No True=Si")

	geBoolean   Usar_Blaster;
	#pragma GE_DefaultValue(Usar_Blaster, "True")
	#pragma GE_Documentation(Usar_Blaster, " Permitir usar el arma Blaster ?. False=No True=Si")

	geBoolean   Sangre_charco;
	#pragma GE_DefaultValue(Sangre_charco, "True")
	#pragma GE_Documentation(Sangre_charco, "Ver charco de sangre al morir jugador. True=Si False=No")

	geBoolean   Inventario_3D;
	#pragma GE_DefaultValue(Inventario_3D, "False")
	#pragma GE_Documentation(Inventario_3D, "Inventario de objetos presenta objeto seleccionado en 3D. True=Si False=No")

	int	Dinero;
	#pragma GE_DefaultValue(Dinero, "0")
	#pragma GE_Documentation(Dinero, "Cantidad de dinero inicial para el jugador")

	geBoolean   QuitaSaludCaidas;
	#pragma GE_DefaultValue(QuitaSaludCaidas, "False")
	#pragma GE_Documentation(QuitaSaludCaidas, "Quita salud al jugador en las caidas. True=Si False=No")

	float	Velocidad;
	#pragma GE_DefaultValue(Velocidad, "4000")
	#pragma GE_Documentation(Velocidad, "Velocidad del jugador corriendo.")

	int	Sombra;
	#pragma GE_DefaultValue(Sombra, "1")
	#pragma GE_Documentation(Sombra, "Tipo de sombra del jugador. (0=Sin sombra, 1=Crculo, 2=Dinmica)")

	geBoolean Sangre;
	#pragma GE_DefaultValue(Sangre, "True")
	#pragma GE_Documentation(Sangre, "Aparece sangre en el jugador por impactos de armas 1 y 4. (True=Si False=No)")

#pragma GE_Origin(Origin)
}   DeathMatchStart;



// MissleTurret
//#pragma GE_Type("Player.ico")
typedef struct	AttackerTurret
{
//#pragma GE_Published
    geVec3d     Origin;
//#pragma GE_Origin(Origin)
}	AttackerTurret;

// PhysicsObject
typedef struct PhysicsObject PhysicsObject;
#pragma GE_Type("Model.ico")
typedef struct	PhysicsObject
{
#pragma GE_Published
  geWorld_Model		*Model;
  geVec3d					Origin;
	float						mass;
	int							isAffectedByGravity;
	int							respondsToForces;
	float						linearDamping;
	float						angularDamping;
	PhysicsObject		*Next;
	float						physicsScale;
#pragma GE_DefaultValue(mass, "10.0")
#pragma GE_DefaultValue(isAffectedByGravity, "1")
#pragma GE_DefaultValue(respondsToForces, "1")
#pragma GE_DefaultValue(linearDamping, "0.0005")
#pragma GE_DefaultValue(angularDamping, "0.0005")
#pragma GE_DefaultValue(physicsScale, "0.01")

#pragma GE_Private
	gePhysicsObject *			stateInfo;
#pragma GE_Origin(Origin)
}	PhysicsObject;

typedef struct PhysicsJoint PhysicsJoint;


// Joint
#pragma GE_Type("Item.ico")
typedef struct  PhysicsJoint
{
#pragma GE_Published
    geVec3d					Origin;
		PhysicsObject *	physicsObject1;
		PhysicsObject *	physicsObject2;
		PhysicsJoint			* Next;
		float						assemblyRate;
		int jointType;
		float physicsScale;
#pragma GE_DefaultValue(assemblyRate, "0.03")
#pragma GE_DefaultValue(physicsScale, "0.01")

#pragma GE_Private
		gePhysicsJoint *			jointData;
#pragma GE_Origin(Origin)
}   PhysicsJoint;

#pragma GE_Type("Item.ico")

// PhysicalSystem
typedef struct PhysicalSystem
{
#pragma GE_Published
	geVec3d						Origin;
	PhysicsObject		*	physicsObjectListHeadPtr;
	PhysicsJoint				*	jointListHeadPtr;
#pragma GE_Private
//		AnyStruct			*	physsysData;
		gePhysicsSystem	*				physsysData;
#pragma GE_Origin(Origin)
} PhysicalSystem;

// ForceField

typedef enum
{
	FALLOFF_NONE = 0,
	FALLOFF_ONE_OVER_D,
	FALLOFF_ONE_OVER_DSQUARED
};

#pragma GE_Type("Item.ico")

typedef struct ForceField
{
#pragma GE_Published
	geVec3d						Origin;
	float							radius;
	float							strength;
	int								falloffType;
	int								affectsPlayers;
	int								affectsPhysicsObjects;

#pragma GE_DefaultValue(radius, "50.0")
#pragma GE_DefaultValue(falloffType, "1")
#pragma GE_DefaultValue(affectsPlayers, "1")
#pragma GE_DefaultValue(affectsPhysicsObjects, "1")

#pragma GE_Origin(Origin)
} ForceField;

// Door
#pragma GE_Type("Model.ico")
typedef struct  Door
{
#pragma GE_Published
    geWorld_Model   *Model;
	geBoolean   Ciclico;
	#pragma GE_DefaultValue(Ciclico, "False")
	#pragma GE_Documentation(Ciclico, "La puerta se abre y se cierra sin parar (True=Si, False=No)")
	geBoolean   Boton_accion;
	#pragma GE_DefaultValue(Boton_accion, "False")
	#pragma GE_Documentation(Boton_accion, " Activacin si botn accin pulsado ? (True=Si, False=No)")
    geVec3d			Origin;
	char *CommandsFile;
	#pragma GE_DefaultValue(CommandsFile, "")
	#pragma GE_Documentation(CommandsFile, "Fichero de comandos (sin extensin .INI)")
#pragma GE_Origin(Origin)
}   Door;

// TextPrompt
#pragma GE_Type("Model.ico")
typedef struct TextPrompt
{
#pragma GE_Published
geWorld_Model *Model;
char *TextInput;
char *TextInput1;
char *TextInput2;
geVec3d Origin;
#pragma GE_Origin(Origin)
} TextPrompt;



// Explosin
#pragma GE_Type("Model.ico")
typedef struct Explosion
{
#pragma GE_Published

int Num_explosion;	
#pragma GE_DefaultValue(Num_explosion, "1")
#pragma GE_Documentation(Num_explosion, "Nmero de explosin (entre 1 y 255)")
	
float Dimension;
#pragma GE_DefaultValue(Dimension, "20")
#pragma GE_Documentation(Dimension, "Tamao de la explosin")

float Velocidad;
#pragma GE_DefaultValue(Velocidad, "10")
#pragma GE_Documentation(Velocidad, "A menos valor, explosin ms lenta")

geVec3d Origin;
#pragma GE_Origin(Origin)
} Explosion;



// Textura animada
#pragma GE_Type("Model.ico")
typedef struct Animacion
{
#pragma GE_Published

geBoolean   Ciclica;
#pragma GE_DefaultValue(Ciclica, "True")
#pragma GE_Documentation(Ciclica, " La animacin se repite continuamente ? (True=Si, False=No)")

char *Sonido;
#pragma GE_DefaultValue(Sonido, "animacion")
#pragma GE_Documentation(Sonido, "Nombre de fichero .WAV a interpretar (sin indicar extensin .WAV)")

float   Transparencia;
#pragma GE_DefaultValue(Transparencia, "255")
#pragma GE_Documentation(Transparencia, "Nivel de transparencia (de 0 a 255). 255 sin transparencia")

geBoolean   Activa;
#pragma GE_DefaultValue(Activa, "False")
#pragma GE_Documentation(Activa, " Animacin activa al iniciar el nivel ? (True=Si, False=No)")

char *Nombre;
#pragma GE_DefaultValue(Nombre, "chica")
#pragma GE_Documentation(Nombre, "Nombre de la secuencia de .BMPs de la animacin.")

int Cuadro_inicial;	
#pragma GE_DefaultValue(Cuadro_inicial, "1")
#pragma GE_Documentation(Cuadro_inicial, "Fotograma inicial de la animacin.")

int Cuadro_final;	
#pragma GE_DefaultValue(Cuadro_final, "8")
#pragma GE_Documentation(Cuadro_final, "Fotograma final de la animacin.")

int Num_animacion;	
#pragma GE_DefaultValue(Num_animacion, "1")
#pragma GE_Documentation(Num_animacion, "Nmero de animacin (entre 1 y 255)")
	
float Dimension;
#pragma GE_DefaultValue(Dimension, "3")
#pragma GE_Documentation(Dimension, "Tamao de la animacin")

float Velocidad;
#pragma GE_DefaultValue(Velocidad, "8")
#pragma GE_Documentation(Velocidad, "A menos valor, animacin ms lenta")

geVec3d Origin;
#pragma GE_Origin(Origin)
} Animacion;





// Command
#pragma GE_Type("Model.ico")
typedef struct Command
{
#pragma GE_Published
	char *CommandsFile;
	#pragma GE_DefaultValue(CommandsFile, "")
	#pragma GE_Documentation(CommandsFile, "Fichero de comandos (sin extensin .INI)")
	geBoolean   Boton_accion;
	#pragma GE_DefaultValue(Boton_accion, "False")
	#pragma GE_Documentation(Boton_accion, " Activacin si botn accin pulsado ? (True=Si, False=No)")
	geBoolean   Visible;
	#pragma GE_DefaultValue(Visible, "False")
	#pragma GE_Documentation(Visible, "Presentar un objeto 3D como referencia de la posicin (True=Si, False=No)")
	geVec3d Origin;
#pragma GE_Origin(Origin)
} Command;






// CommandModel
#pragma GE_Type("Model.ico")
typedef struct CommandModel
{
#pragma GE_Published
	geWorld_Model *Model;
	geBoolean   Boton_accion;
	#pragma GE_DefaultValue(Boton_accion, "False")
	#pragma GE_Documentation(Boton_accion, " Activacin si botn accin pulsado ? (True=Si, False=No)")
	geVec3d Origin;
	char *CommandsFile;
	#pragma GE_DefaultValue(CommandsFile, "")
	#pragma GE_Documentation(CommandsFile, "Fichero de comandos (sin extensin .INI)")
#pragma GE_Origin(Origin)
} CommandModel;


// ItemObject
#pragma GE_Type("Item.ico")
typedef struct  ItemObject
{
#pragma GE_Published
	char *ActorFile;
	char *ObjectName;
	char *ObjectGroup;
	float	Scale; // Vector de escalado
	geVec3d	Orientation; // Vector para orientacin
    geVec3d			Origin;
	geBoolean   Respawn;
	geBoolean   Rotate;
	geBoolean   Catch;
	int			Brillo;
	char *CommandsFile;
	geBoolean   Inventario_objeto;
	float Tiempo_reaparicion;
	int			Usos;
	char *Descrip1;
	char *Descrip2;
	char *Descrip3;
	char *Descrip4;
	int	Precio_venta;
	int	Precio_compra;
	geBoolean   PanelObjeto;
	geBoolean   Boton_accion;
	float   Transparencia;
	int Sombra;

	#pragma GE_DefaultValue(Boton_accion, "False")
	#pragma GE_Documentation(Boton_accion, " Activacin si botn accin pulsado ? (True=Si, False=No)")

	#pragma GE_DefaultValue(PanelObjeto, "True")
	#pragma GE_Documentation(PanelObjeto, " Presenta datos del objeto al tocarlo ? (True=Si, False=No)")

	#pragma GE_DefaultValue(Precio_venta, "0")
	#pragma GE_Documentation(Precio_venta, "Precio al venderlo el jugador (0 gratuito)")

	#pragma GE_DefaultValue(Precio_compra, "0")
	#pragma GE_Documentation(Precio_compra, "Precio al comprarlo el jugador (0 gratuito)")

	#pragma GE_DefaultValue(Descrip1, "")
	#pragma GE_Documentation(Descrip1, "Descripcin del objeto, lnea 1 (28 carac.)")

	#pragma GE_DefaultValue(Descrip2, "")
	#pragma GE_Documentation(Descrip2, "Descripcin del objeto, lnea 2 (28 carac.)")

	#pragma GE_DefaultValue(Descrip3, "")
	#pragma GE_Documentation(Descrip3, "Descripcin del objeto, lnea 3 (28 carac.)")

	#pragma GE_DefaultValue(Descrip4, "")
	#pragma GE_Documentation(Descrip4, "Descripcin del objeto, lnea 4 (28 carac.)")

	#pragma GE_DefaultValue(Usos, "1")
	#pragma GE_Documentation(Usos, "Nmero inicial de usos. (de 1 a 99)")

	#pragma GE_DefaultValue(Brillo, "190")
	#pragma GE_Documentation(Brillo, "Nivel de brillo. (de 0 a 255)")

	#pragma GE_DefaultValue(Catch, "True")
	#pragma GE_Documentation(Catch, " Objeto recogible por el jugador ?. (True=Si  False=No)")

	#pragma GE_DefaultValue(Rotate, "True")
	#pragma GE_Documentation(Rotate, " Objeto girando ?. (True=Si  False=No)")

	#pragma GE_DefaultValue(Respawn, "False")
	#pragma GE_Documentation(Respawn, " Objeto reaparece despus de ser recogido ?. (True=Si  False=No)")

	#pragma GE_DefaultValue(ActorFile, "1_caja.act")
	#pragma GE_Documentation(ActorFile, "Nombre del fichero .ACT del objeto")

	#pragma GE_DefaultValue(ObjectName, "")
	#pragma GE_Documentation(ObjectName, "Nombre completo del objeto")

	#pragma GE_DefaultValue(ObjectGroup, "")
	#pragma GE_Documentation(ObjectGroup, "Grupo al que pertenece el objeto ('Luz' si produce luz)")

	#pragma GE_DefaultValue(Scale, "1")
	#pragma GE_Documentation(Scale, "Tamao (1=Sin variar  2=El doble  0.5=La mitad)")

	#pragma GE_DefaultValue(Orientation, "0 0 0")
	#pragma GE_Documentation(Orientation, "Orientacin")

	#pragma GE_DefaultValue(CommandsFile, "")
	#pragma GE_Documentation(CommandsFile, "Fichero de comandos (sin extensin .INI)")

	#pragma GE_DefaultValue(Inventario_objeto, "True")
	#pragma GE_Documentation(Inventario_objeto, " Al recogerlo se aade al inventario de objetos ?. (True=Si  False=No)")

	#pragma GE_DefaultValue(Tiempo_reaparicion, "60")
	#pragma GE_Documentation(Tiempo_reaparicion, "Tiempo (en segundos) en reaparecer despus de recogido.")

	#pragma GE_DefaultValue(Transparencia, "255")
	#pragma GE_Documentation(Transparencia, "Nivel de transparencia (de 0 a 255). 255 sin transparencia")

	#pragma GE_DefaultValue(Sombra, "1")
	#pragma GE_Documentation(Sombra, "Tipo de sombra. (0=Sin sombra, 1=Crculo, 2=Dinmica)")

#pragma GE_Origin(Origin)
}   ItemObject;


// MovingPlat
#pragma GE_Type("Model.ico")
typedef struct  MovingPlat
{
#pragma GE_Published
    geWorld_Model	*Model;
	geBoolean   Ciclico;
	#pragma GE_DefaultValue(Ciclico, "False")
	#pragma GE_Documentation(Ciclico, "La plataforma se mueve sin parar (True=Si, False=No)")
	geBoolean   Boton_accion;
	#pragma GE_DefaultValue(Boton_accion, "False")
	#pragma GE_Documentation(Boton_accion, " Activacin si botn accin pulsado ? (True=Si, False=No)")
    geVec3d			Origin;
	char *CommandsFile;
	#pragma GE_DefaultValue(CommandsFile, "")
	#pragma GE_Documentation(CommandsFile, "Fichero de comandos (sin extensin .INI)")
#pragma GE_Origin(Origin)
}   MovingPlat;



// ChangeLevel
#pragma GE_Type("Player.ico")
typedef struct ChangeLevel
{
#pragma GE_Private
    geVec3d			Origin;
#pragma GE_Published
    geWorld_Model	*Model;
	char			*LevelName;
	char			*CommandsFile;
	#pragma GE_Documentation(Model, "Nombre del 'model' que activa cargar el nuevo nivel")
	#pragma GE_DefaultValue(LevelName, "")	
	#pragma GE_Documentation(LevelName, "Nombre del nuevo nivel a cargar (no poner la extensin .BSP)")
	#pragma GE_DefaultValue(CommandsFile, "")
	#pragma GE_Documentation(CommandsFile, "Fichero de comandos al iniciar nivel (sin extensin .INI)")
#pragma GE_Origin(Origin)
} ChangeLevel;



// ItemHealth
#pragma GE_Type("Item.ico")
typedef struct  ItemHealth
{
#pragma GE_Private
    geVec3d			Origin;
#pragma GE_Published
	geBoolean   Reaparece;
	geFloat		Incremento;
	int Num_ACT;
	int	Transparencia;
	int Brillo;
	float	Scale; // Vector de escalado
	int Sombra;

	#pragma GE_DefaultValue(Reaparece, "True")
	#pragma GE_Documentation(Reaparece, " Reaparicin transcurridos unos segundos ? (True=Si, False=No)")

	#pragma GE_DefaultValue(Incremento, "25")
	#pragma GE_Documentation(Incremento, "Incremento de salud al recoger el objeto (de 1 a 100)")

	#pragma GE_DefaultValue(Num_ACT, "1")
	#pragma GE_Documentation(Num_ACT, "Determina el modelo 3D que representa la salud (de 1 a 3)")

	#pragma GE_DefaultValue(Scale, "1")
	#pragma GE_Documentation(Scale, "Tamao (1=Sin variar  2=El doble  0.5=La mitad)")

	#pragma GE_DefaultValue(Transparencia, "255")
	#pragma GE_Documentation(Transparencia, "Nivel de transparencia (de 0 a 255, 255=Opaco 128=Semitransparente)")

	#pragma GE_DefaultValue(Brillo, "190")
	#pragma GE_Documentation(Brillo, "Nivel de brillo (de 0 a 255)")

	#pragma GE_DefaultValue(Sombra, "1")
	#pragma GE_Documentation(Sombra, "Tipo de sombra. (0=Sin sombra, 1=Crculo, 2=Dinmica)")

#pragma GE_Origin(Origin)
}   ItemHealth;





// ItemArmor
#pragma GE_Type("Item.ico")
typedef struct ItemArmor
{
#pragma GE_Private
    geVec3d     Origin;
#pragma GE_Published
	geBoolean   Reaparece;
	geFloat		Incremento;
	int	Transparencia;
	int Brillo;
	float	Scale; // Vector de escalado
	int Sombra;

	#pragma GE_DefaultValue(Reaparece, "True")
	#pragma GE_Documentation(Reaparece, " Reaparicin transcurridos unos segundos ? (True=Si, False=No)")

	#pragma GE_DefaultValue(Incremento, "100")
	#pragma GE_Documentation(Incremento, "Incremento de escudo al recoger el objeto (de 1 a 100)")

	#pragma GE_DefaultValue(Scale, "1")
	#pragma GE_Documentation(Scale, "Tamao (1=Sin variar  2=El doble  0.5=La mitad)")

	#pragma GE_DefaultValue(Transparencia, "255")
	#pragma GE_Documentation(Transparencia, "Nivel de transparencia (de 0 a 255, 255=Opaco 128=Semitransparente)")

	#pragma GE_DefaultValue(Brillo, "190")
	#pragma GE_Documentation(Brillo, "Nivel de brillo (de 0 a 255)")

	#pragma GE_DefaultValue(Sombra, "1")
	#pragma GE_Documentation(Sombra, "Tipo de sombra. (0=Sin sombra, 1=Crculo, 2=Dinmica)")

#pragma GE_Origin(Origin)
} ItemArmor;



// ItemRocket
#pragma GE_Type("Item.ico")
typedef struct  ItemRocket
{
#pragma GE_Published
    geVec3d			Origin;
	geBoolean   Reaparece;
	#pragma GE_DefaultValue(Reaparece, "True")
	#pragma GE_Documentation(Reaparece, " Reaparicin transcurridos unos segundos ? (True=Si, False=No)")
#pragma GE_Origin(Origin)
}   ItemRocket;

// ItemRocketAmmo
#pragma GE_Type("Item.ico")
typedef struct  ItemRocketAmmo
{
#pragma GE_Published
    geVec3d			Origin;
	geBoolean   Reaparece;
	#pragma GE_DefaultValue(Reaparece, "True")
	#pragma GE_Documentation(Reaparece, " Reaparicin transcurridos unos segundos ? (True=Si, False=No)")
#pragma GE_Origin(Origin)
}   ItemRocketAmmo;

// ItemGrenade
#pragma GE_Type("Item.ico")
typedef struct  ItemGrenade
{
#pragma GE_Published
    geVec3d			Origin;
	geBoolean   Reaparece;
	#pragma GE_DefaultValue(Reaparece, "True")
	#pragma GE_Documentation(Reaparece, " Reaparicin transcurridos unos segundos ? (True=Si, False=No)")
#pragma GE_Origin(Origin)
}   ItemGrenade;

// ItemGrenadeAmmo
#pragma GE_Type("Item.ico")
typedef struct  ItemGrenadeAmmo
{
#pragma GE_Published
    geVec3d			Origin;
	geBoolean   Reaparece;
	#pragma GE_DefaultValue(Reaparece, "True")
	#pragma GE_Documentation(Reaparece, " Reaparicin transcurridos unos segundos ? (True=Si, False=No)")
#pragma GE_Origin(Origin)
}   ItemGrenadeAmmo;


// ItemBlasterAmmo
#pragma GE_Type("Item.ico")
typedef struct  ItemBlasterAmmo
{
#pragma GE_Published
    geVec3d			Origin;
	geBoolean   Reaparece;
	#pragma GE_DefaultValue(Reaparece, "True")
	#pragma GE_Documentation(Reaparece, " Reaparicin transcurridos unos segundos ? (True=Si, False=No)")
#pragma GE_Origin(Origin)
}   ItemBlasterAmmo;


// ItemShredder
#pragma GE_Type("Item.ico")
typedef struct  ItemShredder
{
#pragma GE_Published
    geVec3d			Origin;
	geBoolean   Reaparece;
	#pragma GE_DefaultValue(Reaparece, "True")
	#pragma GE_Documentation(Reaparece, " Reaparicin transcurridos unos segundos ? (True=Si, False=No)")
#pragma GE_Origin(Origin)
}   ItemShredder;

// ItemShredderAmmo
#pragma GE_Type("Item.ico")
typedef struct  ItemShredderAmmo
{
#pragma GE_Published
    geVec3d			Origin;
	geBoolean   Reaparece;
	#pragma GE_DefaultValue(Reaparece, "True")
	#pragma GE_Documentation(Reaparece, " Reaparicin transcurridos unos segundos ? (True=Si, False=No)")
#pragma GE_Origin(Origin)
}   ItemShredderAmmo;

// FogLight
#pragma GE_Type("FogLight.ico")
typedef struct FogLight
{
#pragma GE_Published
	geVec3d		Origin;
	GE_RGBA		Color;
	float		Brightness;
	float		Radius;
#pragma GE_Origin(Origin)
} FogLight;


// ItemVida
#pragma GE_Type("Item.ico")
typedef struct  ItemVida
{
#pragma GE_Private
    geVec3d			Origin;
#pragma GE_Published
	int	Transparencia;
	int Brillo;
	float	Scale; // Vector de escalado
	int Sombra;

	#pragma GE_DefaultValue(Scale, "1")
	#pragma GE_Documentation(Scale, "Tamao (1=Sin variar  2=El doble  0.5=La mitad)")

	#pragma GE_DefaultValue(Transparencia, "255")
	#pragma GE_Documentation(Transparencia, "Nivel de transparencia (de 0 a 255, 255=Opaco 128=Semitransparente)")

	#pragma GE_DefaultValue(Brillo, "190")
	#pragma GE_Documentation(Brillo, "Nivel de brillo (de 0 a 255)")

	#pragma GE_DefaultValue(Sombra, "1")
	#pragma GE_Documentation(Sombra, "Tipo de sombra. (0=Sin sombra, 1=Crculo, 2=Dinmica)")

#pragma GE_Origin(Origin)
}   ItemVida;


// Cmara fija
#pragma GE_Type("Model.ico")
typedef struct CamaraFija
{
#pragma GE_Published

geBoolean   Activa;
#pragma GE_DefaultValue(Activa, "False")
#pragma GE_Documentation(Activa, " Cmara activa al iniciar el juego ? (True=Si, False=No)")

int Num_camara;
#pragma GE_DefaultValue(Num_camara, "1")
#pragma GE_Documentation(Num_camara, "Nmero de cmara (entre 1 y 64)")
	
float Tiempo;
#pragma GE_DefaultValue(Tiempo, "0")
#pragma GE_Documentation(Tiempo, "Tiempo, en segundos, que estar activa (0 indefinido)")

geVec3d Angulo;
#pragma GE_DefaultValue(Angulo, "0 0 0")
#pragma GE_Documentation(Angulo, "ngulo de inclinacin")

geBoolean   Apunta_al_jugador;
#pragma GE_DefaultValue(Apunta_al_jugador, "False")
#pragma GE_Documentation(Apunta_al_jugador, " Apunta al jugador ? (True=Si, False=No)")

geWorld_Model *	Model;
#pragma GE_Documentation(Model, "Modelo asociado a la cmara. (Opcional)")

Posicion *	Apuntar;
#pragma GE_Documentation(Apuntar, "Posicin hacia donde apunta la cmara. (Opcional)")

geVec3d Origin;
#pragma GE_Origin(Origin)
} CamaraFija;



// Entidad 'Objetivo' para establecer objetivos de la misin
#pragma GE_Type("Item.ico")
typedef struct  Objetivo
{
#pragma GE_Private
    geVec3d			Origin;
#pragma GE_Published
	char *Descripcion;
	#pragma GE_DefaultValue(Descripcion, "Descripcion de un objetivo de la mision")
	#pragma GE_Documentation(Descripcion, "Descripcin de un objetivo de la misin (50 carac. max.)")

	geBoolean En_panel;
	#pragma GE_DefaultValue(En_panel, "True")
	#pragma GE_Documentation(En_panel, "En el panel de objetivos al comenzar el juego. False=No True=Si")

	int Num_objetivo;	
	#pragma GE_DefaultValue(Num_objetivo, "1")
	#pragma GE_Documentation(Num_objetivo, "Nmero de objetivo (de 1 a 10)")

#pragma GE_Origin(Origin)
}   Objetivo;


// Esta estructura ha de ser la misma que haya definida en 'puppet.h' de Genesis3D
#pragma GE_Type("corona.bmp")
typedef struct tagSunLight
{
#pragma GE_Private
	geVec3d	origin;
#pragma GE_Published
	GE_RGBA	color;
	int	light;
	geVec3d	angles;
	int style;
#pragma GE_Origin(origin)
#pragma GE_DefaultValue(light, "150")
#pragma GE_Angles(angles)
#pragma GE_DefaultValue(angles, "0 0 0")
} SunLight ;





// Entidad 'TeclaComandos' para lanzar ficheros de comandos .INI
#pragma GE_Type("Item.ico")
typedef struct  TeclaComandos
{
#pragma GE_Private
    geVec3d			Origin;
#pragma GE_Published
	char *FicheroComandos;
	#pragma GE_DefaultValue(FicheroComandos, "tecla_comandos.ini")
	#pragma GE_Documentation(FicheroComandos, "Nombre del fichero de comandos a lanzar al pulsar la tecla.")

	geBoolean Activa;
	#pragma GE_DefaultValue(Activa, "True")
	#pragma GE_Documentation(Activa, " Tecla activa al dar comienzo el juego ?. False=No True=Si")

	char *Tecla;
	#pragma GE_DefaultValue(Tecla, "U")
	#pragma GE_Documentation(Tecla, "Tecla que lanzar el fichero de comandos.")

	float Retardo;
	#pragma GE_DefaultValue(Retardo, "0.5")
	#pragma GE_Documentation(Retardo, "Tiempo, en segundos, en permitir volver a usar la tecla.")

#pragma GE_Origin(Origin)
}   TeclaComandos;



// Entidad 'Fx_ArmaEnergia' para armas de energa del jugador
#pragma GE_Type("Item.ico")
typedef struct  Fx_ArmaEnergia
{
#pragma GE_Private
    geVec3d			Origin;
#pragma GE_Published

	geBoolean Activa;
	#pragma GE_DefaultValue(Activa, "True")
	#pragma GE_Documentation(Activa, " Arma activa ?. False=No True=Si")

	int Num_ArmaEnergia;
	#pragma GE_DefaultValue(Num_ArmaEnergia, "1")
	#pragma GE_Documentation(Num_ArmaEnergia, "Nmero de arma de energa (de 1 a 20).")

	char *NombreBMP;
	#pragma GE_DefaultValue(NombreBMP, "espiral")
	#pragma GE_Documentation(NombreBMP, "Nombre de la secuencia .BMPs de la animacin (sin extension .BMP)")

	char *NombreBMPa;
	#pragma GE_DefaultValue(NombreBMPa, "espiral")
	#pragma GE_Documentation(NombreBMPa, "Nombre de la secuencia .BMPs (canal Alpha) de la animacin (sin extension .BMP)")

	char *NombreWAV;
	#pragma GE_DefaultValue(NombreWAV, "arma_energia.wav")
	#pragma GE_Documentation(NombreWAV, "Nombre de fichero .WAV a interpretar")

	float Retardo;
	#pragma GE_DefaultValue(Retardo, "0.05")
	#pragma GE_Documentation(Retardo, "Tiempo (en segundos) entre cada imagen BMP")

	float Escala;
	#pragma GE_DefaultValue(Escala, "5")
	#pragma GE_Documentation(Escala, "Tamao del efecto.")

	int Quita_salud;
	#pragma GE_DefaultValue(Quita_salud, "50")
	#pragma GE_Documentation(Quita_salud, "Cantidad de salud a restar a los enemigos.")

	float Altura;
	#pragma GE_DefaultValue(Altura, "140")
	#pragma GE_Documentation(Altura, "Altura del efecto.")

	float   Transparencia;
	#pragma GE_DefaultValue(Transparencia, "130")
	#pragma GE_Documentation(Transparencia, "Nivel de transparencia (de 0 a 255). 255 sin transparencia")

  GE_RGBA	Color;
	#pragma GE_DefaultValue(Color, "255.0 255.0 255.0")
	#pragma GE_Documentation(Color, "Color del efecto")

#pragma GE_Origin(Origin)
}   Fx_ArmaEnergia;




// Entidad 'VolarJugador'
#pragma GE_Type("Player.ico")
typedef struct  VolarJugador
{
#pragma GE_Private
    geVec3d			Origin;
#pragma GE_Published
	geBoolean   Descuenta_energia;
	#pragma GE_DefaultValue(Descuenta_energia, "True")
	#pragma GE_Documentation(Descuenta_energia, " Descuenta energa al volar ?. True=Si False=No")

	geBoolean   Inicio_volando;
	#pragma GE_DefaultValue(Inicio_volando, "False")
	#pragma GE_Documentation(Inicio_volando, " Iniciar el nivel volando ?. True=Si False=No")

	geBoolean   Pemitir_OnOff;
	#pragma GE_DefaultValue(Pemitir_OnOff, "True")
	#pragma GE_Documentation(Pemitir_OnOff, " Permitir al jugador activar/desactivar volar ?. True=Si False=No")

	geBoolean   Sonido_volar;
	#pragma GE_DefaultValue(Sonido_volar, "True")
	#pragma GE_Documentation(Sonido_volar, " Sonido de propulsin al volar el jugador ?. False=No True=Si")

	geBoolean   Sonido_volando;
	#pragma GE_DefaultValue(Sonido_volando, "True")
	#pragma GE_Documentation(Sonido_volando, " Sonido mientras vuela el jugador ?. False=No True=Si")

	geVec3d	Posicion_XY;
	#pragma GE_DefaultValue(Posicion_XY, "15 -220 1")
	#pragma GE_Documentation(Posicion_XY, "Posicin de la barra de energa en pantalla. (Slo X Y)")

	float	Retardo;
	#pragma GE_DefaultValue(Retardo, "0.5")
	#pragma GE_Documentation(Retardo, "Velocidad de vaciado de la energa. (En segundos)")

	int	Energia;
	#pragma GE_DefaultValue(Energia, "100")
	#pragma GE_Documentation(Energia, "Energia inicial de la barra de energa (de 0 a 100 )")

	char *Comandos_Vacia;
	#pragma GE_DefaultValue(Comandos_Vacia, "")
	#pragma GE_Documentation(Comandos_Vacia, "Nombre del fichero de comandos a lanzar cuando se acabe la energa")

#pragma GE_Origin(Origin)
}   VolarJugador;




#ifdef __cplusplus
}
#endif

#pragma warning( default : 4068 )

#endif
