/****************************************************************************************/
/*  Modificaciones para Entidad 3D:                                                     */
/*                                                                                      */
/*  Autor: Jordi Prez                                                                  */
/*                                                                                      */
/*  Copyright (c) 2005 Jordi Prez; All rights reserved.                                */
/*                                                                                      */
/*                                                                                      */
/****************************************************************************************/

#ifndef	BOTACTOR_H
#define	BOTACTOR_H

#include	"genesis.h"

#pragma warning( disable : 4068 )


// ****************************************************************************************
// Entidad 'Posicion' para establecer posiciones X Y Z en el nivel para diversos usos
#pragma GE_Type("Item.ico")
typedef struct  Posicion
{
#pragma GE_Published
    geVec3d			Origin;
	#pragma GE_Documentation(Origin, "Posicin X Y Z")

	int Num_posicion;
	#pragma GE_DefaultValue(Num_posicion, "1")
	#pragma GE_Documentation(Num_posicion, "Nmero de posicin. (Entre 1 y 255)")

#pragma GE_Origin(Origin)
}   Posicion;



// ****************************************************************************************
// Entidad 'BotActorStart' para definir enemigos y personajes secundarios
#pragma GE_Type("BotActor.bmp")
typedef struct BotActorStart BotActorStart;

#pragma GE_Type("BotActor.bmp")
typedef struct BotActorStart {
#pragma GE_Published

	geVec3d		origin;
	geBoolean   Respawn;
	geBoolean	Retreat;
	geBoolean   IgnoreTurrets;
	int			SkillLevel;
	int			EnemyNumber;
	geBoolean   WeaponShredder;
	geBoolean   WeaponGrenades;
	geBoolean   WeaponRockets;
	geBoolean   WeaponBlaster;
	int			WeaponShredderA;
	int			WeaponGrenadesA;
	int			WeaponRocketsA;
	int			WeaponBlasterA;
	int			HealthLevel;
	char		*CommandsFile;
	geBoolean   Static_Bot;
	geBoolean   Se_detiene;
	float		Tiempo_reaparicion;
	float		Velocidad;
	int			Quita_salud;
	geBoolean   Dispara;
	geBoolean	Inicio_parado;
	float		Tiempo_corriendo;
	geBoolean	Cobarde;
	geBoolean	Abalanzarse;
	geBoolean   Masculino;
	geBoolean	Sangre;
	float		Tiempo_sonido;
	geBoolean	Indiferente;
	geBoolean	Buscar;
	float		DistanciaMin;
	int			BuscarPorc;
	int			CobardePorc;
	int			IndiferentePorc;
	geBoolean	AnimacionTipo;
	geBoolean	Bloqueo; // Colisin con este Enemigo (True/False)
	char		*Comandos_colision;
	float		Scale;
    Posicion *	Destino1;
    Posicion *	Destino2;
    Posicion *	Destino3;
    Posicion *	Destino4;
    Posicion *	Destino5;
	int			Inmune;
	geBoolean   Mov_lateral_azar;
	geBoolean   Dispara1_parado;
	geBoolean   Dispara2_parado;
	geBoolean   Dispara3_parado;
	geBoolean   Dispara4_parado;
	float		Distancia1_disparar;
	float		Distancia2_disparar;
	float		Distancia3_disparar;
	float		Distancia4_disparar;
	int			InmuneEnergia;
	geBoolean	ExplosionMorir;
	float		Min_zona_critica;
	float		Max_zona_critica;

	#pragma GE_DefaultValue(CommandsFile, "")
	#pragma GE_Documentation(CommandsFile, "Fichero .INI de comandos para procesar cuando muere")

	#pragma GE_DefaultValue(SkillLevel, "5")
	#pragma GE_Documentation(SkillLevel, "Nivel de dificultad. De 1 a 10. El 1 es el ms difcil.")

	#pragma GE_DefaultValue(Respawn, "False")
	#pragma GE_Documentation(Respawn, "Reaparicin del enemigo despus de muerto. True=Si False=No")

	#pragma GE_DefaultValue(Retreat, "False")
	#pragma GE_Documentation(Retreat, "<sin funcin>.")

	#pragma GE_DefaultValue(IgnoreTurrets, "True")
	#pragma GE_Documentation(IgnoreTurrets, "<sin funcin>.")

	#pragma GE_DefaultValue(EnemyNumber, "0")
	#pragma GE_Documentation(EnemyNumber, "Nmero de enemigo a mostrar. De 0 a 8. 0=Al azar entre 1 y 6, 1 a 8=Enemigo especfico.")

	#pragma GE_DefaultValue(WeaponBlaster, "True")
	#pragma GE_Documentation(WeaponBlaster, "Arma 1 (Blaster) en el inventario.")

	#pragma GE_DefaultValue(WeaponBlasterA, "255")
	#pragma GE_Documentation(WeaponBlasterA, "Cantidad de municin inicial para el Blaster.")

	#pragma GE_DefaultValue(WeaponShredder, "False")
	#pragma GE_Documentation(WeaponShredder, "Metralleta en el inventario.")

	#pragma GE_DefaultValue(WeaponShredderA, "50")
	#pragma GE_Documentation(WeaponShredderA, "Cantidad de municin inicial para la Metralleta.")

	#pragma GE_DefaultValue(WeaponGrenades, "False")
	#pragma GE_Documentation(WeaponGrenades, "Lanza-granadas en el inventario.")

	#pragma GE_DefaultValue(WeaponGrenadesA, "20")
	#pragma GE_Documentation(WeaponGrenadesA, "Cantidad de municin inicial para el Lanza-granadas.")

	#pragma GE_DefaultValue(WeaponRockets, "False")
	#pragma GE_Documentation(WeaponRockets, "Arma Lanza-cohetes en el inventario.")

	#pragma GE_DefaultValue(WeaponRocketsA, "15")
	#pragma GE_Documentation(WeaponRocketsA, "Cantidad de municin inicial para el Lanza-cohetes.")

	#pragma GE_DefaultValue(HealthLevel, "50")
	#pragma GE_Documentation(HealthLevel, "Salud inicial. De 1 a 100.")

	#pragma GE_DefaultValue(Static_Bot, "False")
	#pragma GE_Documentation(Static_Bot, "Enemigo esttico. (False=No True=Si)")

	#pragma GE_DefaultValue(Se_detiene, "False")
	#pragma GE_Documentation(Se_detiene, "El enemigo, en ocasiones, se detiene. (False=No True=Si)")

	#pragma GE_DefaultValue(Tiempo_reaparicion, "120")
	#pragma GE_Documentation(Tiempo_reaparicion, "Tiempo (en segundos) en reaparecer despus de muerto.")

	#pragma GE_DefaultValue(Velocidad, "3700")
	#pragma GE_Documentation(Velocidad, "Velocidad del enemigo. Mayor valor mayor velocidad")

	#pragma GE_DefaultValue(Quita_salud, "5")
	#pragma GE_Documentation(Quita_salud, "Cantidad de salud que resta al jugador al tocar este enemigo.")

	#pragma GE_DefaultValue(Dispara, "True")
	#pragma GE_Documentation(Dispara, "Enemigo dispara. (True=Si False=No)")

	#pragma GE_DefaultValue(Inicio_parado, "True")
	#pragma GE_Documentation(Inicio_parado, "Al comenzar, enemigo parado si no ve al jugador. (True=Si False=No)")

	#pragma GE_DefaultValue(Tiempo_corriendo, "20")
	#pragma GE_Documentation(Tiempo_corriendo, "Tiempo (en segundos) corriendo cuando no ve al jugador.")

	#pragma GE_DefaultValue(Cobarde, "False")
	#pragma GE_Documentation(Cobarde, "El enemigo huye del jugador y no dispara. (True=Si False=No)")

	#pragma GE_DefaultValue(CobardePorc, "0")
	#pragma GE_Documentation(CobardePorc, "Porcentaje de tiempo cobarde (0 - 100)(0 no usar porcentaje)")

	#pragma GE_DefaultValue(Abalanzarse, "False")
	#pragma GE_Documentation(Abalanzarse, "Se abalanza hacia el jugador. (True=Si False=No)")

	#pragma GE_DefaultValue(Masculino, "True")
	#pragma GE_Documentation(Masculino, " El enemigo es del sexo masculino ?. (True=Masculino  False=Femenino)")

	#pragma GE_DefaultValue(Sangre, "True")
	#pragma GE_Documentation(Sangre, "Aparece sangre en impactos por armas 1 y 4. (True=Si False=No)")

	#pragma GE_DefaultValue(Tiempo_sonido, "0")
	#pragma GE_Documentation(Tiempo_sonido, "Intrvalo de tiempo para interpretar el sonido de este enemigo")

	#pragma GE_DefaultValue(Indiferente, "False")
	#pragma GE_Documentation(Indiferente, "Se mantiene prximo al jugador dando vueltas. (True=Si False=No)")

	#pragma GE_DefaultValue(IndiferentePorc, "0")
	#pragma GE_Documentation(IndiferentePorc, "Porcentaje de tiempo indiferente (0 - 100)(0 no usar porcentaje)")

	#pragma GE_DefaultValue(Buscar, "True")
	#pragma GE_Documentation(Buscar, "Busca al jugador esquivando obstculos. (True=Si False=No)")

	#pragma GE_DefaultValue(BuscarPorc, "0")
	#pragma GE_Documentation(BuscarPorc, "Porcentaje de tiempo buscando al jugador (0 - 100)(0 no usar porcentaje)")

	#pragma GE_DefaultValue(DistanciaMin, "400")
	#pragma GE_Documentation(DistanciaMin, "Distancia mnima entre enemigo y jugador. (entre 50 y 5000)")

	#pragma GE_DefaultValue(AnimacionTipo, "False")
	#pragma GE_Documentation(AnimacionTipo, "Animacin al desplazarse. (False=Correr(Run) True=Andar(Walk))")

	#pragma GE_DefaultValue(Bloqueo, "True")
	#pragma GE_Documentation(Bloqueo, " Detectar colisin con jugador ? (True=Si  False=No)")

	#pragma GE_DefaultValue(Comandos_colision, "")
	#pragma GE_Documentation(Comandos_colision, "Fichero .INI de comandos para procesar al colisionar")

	#pragma GE_DefaultValue(Scale, "2.7")
	#pragma GE_Documentation(Scale, "Tamao (2.7=Normal  5.4=El doble  1.3=La mitad)")

	#pragma GE_Documentation(Destino1, "Destino 1 de la ruta")
	#pragma GE_Documentation(Destino2, "Destino 2 de la ruta")
	#pragma GE_Documentation(Destino3, "Destino 3 de la ruta")
	#pragma GE_Documentation(Destino4, "Destino 4 de la ruta")
	#pragma GE_Documentation(Destino5, "Destino 5 de la ruta")

	#pragma GE_DefaultValue(Inmune, "0")
	#pragma GE_Documentation(Inmune, "Inmunidad. 0=No inmune. 1 a 4 inmune a ese nivel de arma")

	#pragma GE_DefaultValue(Mov_lateral_azar, "False")
	#pragma GE_Documentation(Mov_lateral_azar, "Movimientos laterales aleatorios. (True=Si False=No)")

	#pragma GE_DefaultValue(Dispara1_parado, "False")
	#pragma GE_Documentation(Dispara1_parado, "Siempre dispara el arma 1 parado. (True=Si False=No)")

	#pragma GE_DefaultValue(Dispara2_parado, "False")
	#pragma GE_Documentation(Dispara2_parado, "Siempre dispara el arma 2 parado. (True=Si False=No)")

	#pragma GE_DefaultValue(Dispara3_parado, "False")
	#pragma GE_Documentation(Dispara3_parado, "Siempre dispara el arma 3 parado. (True=Si False=No)")

	#pragma GE_DefaultValue(Dispara4_parado, "False")
	#pragma GE_Documentation(Dispara4_parado, "Siempre dispara o ataca con el arma 4 parado. (True=Si False=No)")

	#pragma GE_DefaultValue(Distancia1_disparar, "5000")
	#pragma GE_Documentation(Distancia1_disparar, "Distancia mnima hasta el jugador para usar arma 1 (50 a 10000)")

	#pragma GE_DefaultValue(Distancia2_disparar, "1000")
	#pragma GE_Documentation(Distancia2_disparar, "Distancia mnima hasta el jugador para usar arma 2 (50 a 10000)")

	#pragma GE_DefaultValue(Distancia3_disparar, "3000")
	#pragma GE_Documentation(Distancia3_disparar, "Distancia mnima hasta el jugador para usar arma 3 (50 a 10000)")

	#pragma GE_DefaultValue(Distancia4_disparar, "10000")
	#pragma GE_Documentation(Distancia4_disparar, "Distancia mnima hasta el jugador para usar arma 4 (50 a 10000)")

	#pragma GE_DefaultValue(InmuneEnergia, "0")
	#pragma GE_Documentation(InmuneEnergia, "Inmunidad a armas de energa. -1=A todas, 0=A ninguna, Arma 1 a 20 que le daa")

	#pragma GE_DefaultValue(ExplosionMorir, "False")
	#pragma GE_Documentation(ExplosionMorir, "Explosin del enemigo al morir. (True=Si False=No)")

	#pragma GE_DefaultValue(Min_zona_critica, "0")
	#pragma GE_Documentation(Min_zona_critica, "Inicio, en %, de la zona crtica mnima del enemigo (de 0 a 100) 0 sin zona ")

	#pragma GE_DefaultValue(Max_zona_critica, "0")
	#pragma GE_Documentation(Max_zona_critica, "Inicio, en %, de la zona crtica mxima del enemigo (de 0 a 100) 0 sin zona")

#pragma GE_Private

	char		*Ptr;

#pragma GE_Origin(origin)
} BotActorStart;



#pragma GE_Type("BlockActor.bmp")
typedef struct BlockActor BlockActor;

#pragma GE_Type("BlockActor.bmp")
typedef struct BlockActor {
#pragma GE_Published

geVec3d		Origin;
geWorld_Model *Model;

#pragma GE_Documentation(Model, "Blocking Model - Actors will not move into this model.")

#pragma GE_Origin(Origin)
} BlockActor;

#pragma warning( default : 4068 )

#endif
